alias ftp if ($2 == $null) { set -u1 %p 21 } | else { set -u1 %p $2 } | if (%ftp.dir == $null) { set %ftp.dir $getdir } | sockopen ftp. $+ $1 $1 %p
alias ftp.login sockwrite -n $1 user $$?="enter username"
alias ftp.pass sockwrite -n $1 pass $$?*="enter password"
alias ftp.sendfile {
  bread %tfile. [ $+ [ $1 ] ] %tspos. [ $+ [ $1 ] ] 4096 &temp
  sockwrite send. [ $+ [ $1 ] ] &temp
  inc %tspos. [ $+ [ $1 ] ] $bvar(&temp,0)
}
alias ftp.parse {
  set %name $right($1,$calc($len($1) - 5))
  if ($2 == ls) || ($2 == dir) {
    sockclose port. $+ %name
    sockclose data. $+ %name
    sockwrite -n ftp. $+ %name type a
    set %ftp.type a
    if (%port == $null) set %port 197
    inc %port 3
    if (%port > 250) { %port = 200 }
    sockwrite -n ftp. $+ %name port $replace($ip,$chr(46),$chr(44)) $+ ,4, $+ %port
    set -u1 %l 0.0.4. $+ %port
    socklisten port. $+ %name $longip(%l)
    sockwrite -n ftp. $+ %name list
    sockwrite -n ftp. $+ %name pwd
  }
  elseif ($2 == del) { sockwrite -n ftp. $+ %name dele $3- }
  elseif ($2 == cwd) || ($2 == cd) {
    sockwrite -n ftp. $+ %name cwd $3-
    sockwrite -n ftp. $+ %name pwd
  }
  elseif ($2 == mkdir) || ($2 == md) { sockwrite -n ftp. $+ %name mkd $3- }
  elseif ($2 == ren) || ($2 == rename) {
    sockwrite -n ftp. $+ %name rnfr $3
    sockwrite -n ftp. $+ %name rnto $4
  }
  elseif ($2 == rmdir) { sockwrite -n ftp. $+ %name rmd $3- }
  elseif ($2 == get) {
    if $3- == $null halt
    %fget. [ $+ [ %name ] ] = $3-
    set -u1 %s %ftp.dir [ $+ [ %fget. [ $+ [ %name ] ] ] ]
    if ($exists(%s) == $true) && ($?!="file exists! overwrite?" == $false) halt
    .remove %ftp.dir $+ %fget. $+ %name
    sockclose get. $+ %name
    if (%ftp.type == a) && ($?!="type is ASCII - change to BINARY?" == $true) {
      set %ftp.type i
      sockwrite -n ftp. $+ %name type %ftp.type
    }
    if (%port == $null) set %port 197
    inc %port 3
    if (%port > 250) { %port = 200 }
    sockwrite -n ftp. $+ %name port $replace($ip,$chr(46),$chr(44)) $+ ,4, $+ %port
    set -u1 %l 0.0.4. $+ %port
    socklisten get. $+ %name $longip(%l)
    sockwrite -n ftp. $+ %name retr %fget. [ $+ [ %name ] ]
  }
  elseif ($2 == type) {
    if ($left($3,1) == a) { set %ftp.type a }
    else { set %ftp.type i }
    sockwrite -n ftp. $+ %name type %ftp.type
  }
  elseif ($2 == bin) {
    set %ftp.type i
    sockwrite -n ftp. $+ %name type %ftp.type
  }
  elseif (asc* iswm $2) {
    set %ftp.type a
    sockwrite -n ftp. $+ %name type %ftp.type
  }
  elseif ($2 == put) || ($1 == send) {
    %tfile. [ $+ [ %name ] ] = $dir %ftp.dir
    if (%tfile. [ $+ [ %name ] ] == $null) halt
    %tspos. [ $+ [ %name ] ] = 0
    set -u1 %s %tfile. [ $+ [ %name ] ]
    %tlof. [ $+ [ %name ] ] = $file(%s).size
    sockclose send. $+ %name
    if (%ftp.type == a) && ($?!="type is ASCII - change to BINARY?" == $true) {
      set %ftp.type i
      sockwrite -n ftp. $+ %name type %ftp.type
    }
    if (%port == $null) set %port 197
    inc %port 3
    if (%port > 250) { %port = 200 }
    set -u1 %s %tfile. [ $+ [ %name ] ]
    sockwrite -n ftp. $+ %name port $replace($ip,$chr(46),$chr(44)) $+ ,4, $+ %port
    sockwrite -n ftp. $+ %name pasv
    sockwrite -n ftp. $+ %name stor $nopath(%s)
  }
  elseif ($2 == lcd) {
    set %ftp.dir $sdir="select local directory" %ftp.dir
    echo 3 -t @ftp@ $+ %name ws local directory: %ftp.dir
  }
  elseif ($2 == bye) || ($2 == quit) || ($2 == exit) { sockwrite -n ftp. $+ %name quit }
  elseif ($2 == help) {
    echo 3 -t @ftp@ $+ %name ws commands: ascii, bin, bye, cd, del, dir, exit, get, lcd, ls, mkdir, put, rmdir, type, quit
    echo 3 -t @ftp@ $+ %name ws all other commands will be sent to the server.
  }
  elseif ($left($2,1) == /) { $2- }
  else { sockwrite -n ftp. $+ %name $2- }
  halt
}
ON 1:SOCKLISTEN:get.*:{
  set %name $right($sockname,$calc($len($sockname) - 5))
  set %get. $+ $right($sockname,$calc($len($sockname) - 4)) 0
  set %gtime. $+ $right($sockname,$calc($len($sockname) - 4)) $ticks
  sockaccept file. $+ $right($sockname,$calc($len($sockname) - 4))
}
ON 1:SOCKREAD:file.*:{
  set %name $right($sockname,$calc($len($sockname) - 5))
  :more
  sockread &temp
  bwrite %ftp.dir $+ %fget. [ $+ [ %name ] ] -1 &temp
  inc %get. $+ %name $bvar(&temp,0)
  set -u1 %t %get. [ $+ [ %name ] ]
  titlebar @ftp@ $+ %name downloaded $bsize(%t) of %tfile. [ $+ [ %name ] ]
  if ($sock(rf).rq > 0) goto more
}
ON 1:SOCKCLOSE:file.*:{
  set %name $right($sockname,$calc($len($sockname) - 5))
  titlebar @ftp@ $+ %name
  set -u1 %tt1 %gtime. [ $+ [ %name ] ]
  set -u1 %tt1 $calc($calc($ticks - %tt1) / 60)
  set -u1 %s %ftp.dir $+ %fget. [ $+ [ %name ] ]
  set -u1 %tt2 $file(%s).size
  echo 3 -t @ftp@ $+ %name ws transfer of $nopath(%s) complete ( $+ $bsize($round($calc(%tt2 / %tt1),2)) sec)
}
ON 1:SOCKLISTEN:port.*:{
  sockaccept data. $+ $right($sockname,$calc($len($sockname) - 5))
  set %no. $+ $right($sockname,$calc($len($sockname) - 5)) 1
}
ON 1:SOCKREAD:data.*:{
  set -u2 %name $right($sockname,$calc($len($sockname) - 5))
  :rep
  sockread %ftp.temp
  if ($sockbr == 0) { return }
  if (%ftp.temp == $null ) { set %ftp.temp $chr(13) }
  set -u2 %tt $gettok(%ftp.temp,1,32) $gettok(%ftp.temp,9,32)
  set -u2 %si $bsize($gettok(%ftp.temp,5,32))
  if ($calc(%no. [ $+ [ %name ] ] % 2) == 0) { set -u1 %d 6 }
  else { set -u1 %d 3 }
  echo %d -t @ftp@ $+ %name ws %tt $str(,$abs($calc($len(%tt) - 50))) %si $str(,$abs($calc($len(%si) - 15))) $gettok(%ftp.temp,6,32) $str(,$abs($calc($len($gettok(%ftp.temp,7,32)) - 2))) $+ $gettok(%ftp.temp,7,32) $gettok(%ftp.temp,8,32) 
  inc %no. $+ %name 1
  goto rep
}
ON 1:INPUT:@ftp*:{
  .timer -m 1 0.2 ftp.parse $active $1-
  set -u1 %name ftp. $+ $right($active,$calc($len($active) - 5))
  .timer $+ %name 1 60 sockwrite -n %name noop
  halt
}
ON 1:SOCKOPEN:ftp.*:{
  set -u2 %name $right($sockname,$calc($len($sockname) - 4))
  if $sockerr > 0 { echo 5 -at ws unable to connect to %name | return }
  window -ae @ftp@ $+ %name
  echo 3 -t @ftp@ $+ %name ws %logo ftp client v1.01 - by DaftHunk
  echo 3 -t @ftp@ $+ %name ws -
  echo 3 -t @ftp@ $+ %name ws connected to %name $+ ...
}
ON 1:SOCKREAD:ftp.*:{
  set -u20 %name $right($sockname,$calc($len($sockname) - 4))
  if ($sockerr > 0) { echo -t @ftp@ $+ %name ws connection to %name failed. | return }
  :nextread
  sockread -f %temp
  if ($sockbr == 0) return
  set -u2 %tmp $left(%temp,4)
  if (%tmp == 220 ) { echo 3 -t @ftp@ $+ %name ws ok to send username | .timer 1 1 ftp.login $sockname }
  elseif (%tmp == 331 ) { .timer 1 1 ftp.pass $sockname }
  elseif (%tmp == 227 ) {
    %useport = $remove($gettok(%temp,2,40),$chr(41))
    %useport = 0.0. $+ $gettok(%useport,5,44) $+ . $+ $gettok(%useport,6,44)
    echo 3 -t @ftp@ $+ %name ws initiating file transfer...
    sockopen send. $+ %name %name $longip(%useport) 
  }
  echo 12 -t @ftp@ $+ %name ws %temp
  goto nextread
}
ON 1:SOCKOPEN:send.*:{
  set -u2 %name $right($sockname,$calc($len($sockname) - 5))
  if ($sockerr > 0) { echo 3 -t @ftp@ $+ %name ws unable to start transfer | return }
  echo 3 -t @ftp@ $+ %name ws starting transfer...
  set %stime. $+ %name $ticks
  ftp.sendfile %name
}
ON 1:SOCKWRITE:send.*:{
  set -u2 %name $right($sockname,$calc($len($sockname) - 5))
  if ($sockerr > 0) { echo 3 -t @ftp@ $+ %name ws error in file transfer | return }
  if (%tspos. [ $+ [ %name ] ] >= %tlof. [ $+ [ %name ] ]) {
    titlebar @ftp@ $+ %name
    sockclose send. [ $+ [ %name ] ]
    set -u1 %tt1 %stime. [ $+ [ %name ] ]
    set -u1 %tt1 $calc($calc($ticks - %tt1) / 60)
    set -u1 %tt2 %tlof. [ $+ [ %name ] ]
    set -u1 %tt1 $round($calc(%tt2 / %tt1),2)
    set -u1 %s %tfile. [ $+ [ %name ] ]
    echo 3 -t @ftp@ $+ %name ws transfer of $nopath(%s) complete ( $+ $bsize(%tt1) sec)
    return
  }
  titlebar @ftp@ $+ %name uploaded $round($calc(%tspos. [ $+ [ %name ] ] / %tlof. [ $+ [ %name ] ] * 100),2) $+ % of %tfile. [ $+ [ %name ] ]
  ftp.sendfile %name
}
ON 1:SOCKCLOSE:send.*:{
  echo -at closing
  titlebar @ftp@ $+ $right($sockname,$calc($len($sockname) - 5))
}
ON 1:SOCKCLOSE:ftp.*:echo 5 -t @ftp@ $+ $right($sockname,$calc($len($sockname) - 4)) ws session ended
